// 
// Created on:  6/7/21

#include <iostream>
#include <cstdlib>
#include <filesystem>
#include <string>
#include <stdexcept>
#include "DataCategory.hpp"
int main(int argc, const char * argv[]) {
	
	if (argc <2) {
		std::cerr << "Requires the file name to check" << std::endl;
		return EXIT_FAILURE;
	}
	std::string filename = std::string(argv[1]);
	if (!std::filesystem::exists(std::filesystem::path(filename))){
		std::cerr << "Does not exist: "<<filename << std::endl;
		return EXIT_FAILURE;
	}
	
	// Are we doing a single file, or the entire DFN table
	if (std::filesystem::is_directory(std::filesystem::path(filename))){
		// first see if doing all categories, or just one
		int cat = -1 ;
		DataCategory category ;

		if (argc >2){
			try {
				cat = std::stoi(std::string(argv[2]));
			}
			catch(...){
				std::cerr <<"Can not process category number: " <<std::string(argv[2])<<std::endl;
				return EXIT_FAILURE;
			}
			try {
				std::cout << "Checking category: " << cat << std::endl;
				category.loadData(filename, static_cast<DEFINITIONCATEGORIES>(cat)) ;
			}
			catch(const std::runtime_error &e){
				std::cerr << e.what() << std::endl;
				return EXIT_FAILURE;
			}
		}
		else {
			try {
				
			// we want to do them all
			std::cout << "Checking items..." << std::endl;
			category.loadData(filename, items_def) ;
			std::cout << "Checking npcs..." << std::endl;
			category.loadData(filename, npc_def) ;
			std::cout << "Checking create..." << std::endl;
			category.loadData(filename, create_def) ;
			std::cout << "Checking region..." << std::endl;
			category.loadData(filename, regions_def) ;
			std::cout << "Checking misc..." << std::endl;
			category.loadData(filename, misc_def) ;
			std::cout << "Checking skills..." << std::endl;
			category.loadData(filename, skills_def) ;
			std::cout << "Checking location..." << std::endl;
			category.loadData(filename, location_def) ;
			std::cout << "Checking menus..." << std::endl;
			category.loadData(filename, menus_def) ;
			std::cout << "Checking spells..." << std::endl;
			category.loadData(filename, spells_def) ;
			std::cout << "Checking newbie..." << std::endl;
			category.loadData(filename, newbie_def) ;
			std::cout << "Checking titles..." << std::endl;
			category.loadData(filename, titles_def) ;
			std::cout << "Checking advance..." << std::endl;
			category.loadData(filename, advance_def) ;
			std::cout << "Checking house..." << std::endl;
			category.loadData(filename, house_def) ;
			std::cout << "Checking colors..." << std::endl;
			category.loadData(filename, colors_def) ;
			std::cout << "Checking spawn..." << std::endl;
			category.loadData(filename, spawn_def) ;
			std::cout << "Checking html..." << std::endl;
			category.loadData(filename, html_def) ;
			std::cout << "Checking race..." << std::endl;
			category.loadData(filename, race_def) ;
			std::cout << "Checking weather..." << std::endl;
			category.loadData(filename, weathab_def) ;
			std::cout << "Checking harditems..." << std::endl;
			category.loadData(filename, hard_items_def) ;
			std::cout << "Checking command..." << std::endl;
			category.loadData(filename, command_def) ;
			std::cout << "Checking msgboard..." << std::endl;
			category.loadData(filename, msgboard_def) ;
			std::cout << "Checking carve..." << std::endl;
			category.loadData(filename, carve_def) ;
			std::cout << "Checking creatures..." << std::endl;
			category.loadData(filename, creatures_def) ;
			std::cout << "Checking maps..." << std::endl;
			category.loadData(filename, maps_def) ;
			}
			catch(const std::runtime_error &e){
				std::cerr << e.what()<<std::endl;
				return EXIT_FAILURE;
			}

		}
		std::cout <<"No syntax errors detected " << std::endl ;

	}
	else {
		// Just a single file!
		try {
			auto category = DataCategory(filename) ;
		}
		catch(const std::runtime_error &e) {
			std::cerr << e.what() << std::endl;
			return EXIT_FAILURE;
			
		}
		std::cout <<"No syntax errors detected in " << filename<< std::endl;
	}
	return EXIT_SUCCESS;
}
